		#include        p16f1827.inc

                __CONFIG   _CONFIG1, _FCMEN_OFF & _IESO_OFF & _CLKOUTEN_OFF & _CP_OFF & _BOREN_ON & _MCLRE_OFF & _PWRTE_OFF & _WDTE_ON & _FOSC_INTOSC
                __CONFIG   _CONFIG2, _LVP_OFF & _PLLEN_OFF

                                ;Code for Desktop thermometer 
                                 
                                ;********************
                                ;Still to do:
                                ;********************

;PIN	1	RA2	DO	V2 Anode
;PIN	2	RA3	DO	V3 Anode
;PIN	3	RA4	DO	V4 Anode
;PIN	4	RA5	DI	Serial data - not used
;PIN	5	Vss	
;PIN	6	RB0	DO	74141 'C'
;PIN	7	RB1	DO	V5 Anode
;PIN	8	RB2	DIO	SDA/DHT11 ext
;PIN	9	RB3	DO	PWM out P1A

;PIN	10	RB4	DI	IR receiver
;PIN	11	RB5	DIO	SCL/DHT11 int
;PIN	12	RB6	D0	IR transmitter PWM P2A
;PIN	13	RB7	DO	74141 'B'
;PIN	14	Vdd	
;PIN	15	RA6	DO	74141 'D'
;PIN	16	RA7	DO	V1 Anode
;PIN	17	RA0	DIO	Force ext/int data display
;PIN	18	RA1	DO	74141 'A'




;-----------------------------                                
;I/O data from OS for user program found from 20-7fh:
;-----------------------------

DVAR			equ 	0x20	;delay loop counter 1
DVAR2           equ 	0x21	;delay loop counter 2
cat1         	equ     0x22    ;Byte to send to cathode 1
cat2         	equ     0x23    ;Byte to send to cathode 2
cat3         	equ     0x24    ;Byte to send to cathode 3
cat4         	equ     0x25    ;Byte to send to cathode 4
cat5         	equ     0x26    ;Byte to send to cathode 5
Old_cat1      	equ     0x27    ;Old byte to send to cathode 1
Old_cat2      	equ     0x28    ;Old byte to send to cathode 2
Old_cat3      	equ     0x29    ;Old byte to send to cathode 3
Old_cat4      	equ     0x2a    ;Old byte to send to cathode 4
Old_cat5      	equ     0x2b    ;Old byte to send to cathode 5
;Old_cat1c	    equ     0x2c    ;Old byte to send to cathode shift register 1
IRcount	        equ     0x2d    ;IR pulses received counter
DispCyc	        equ     0x2e    ;Counter for display cycling
DispRnd	        equ     0x2f    ;random number for display cycling

;Display bytes 1- Degrees C
Ccat1         	equ     0x30    ;Byte to send to cathode 1
Ccat2         	equ     0x31    ;Byte to send to cathode 2
Ccat3         	equ     0x32    ;Byte to send to cathode 3
Ccat4         	equ     0x33    ;Byte to send to cathode 4
Ccat5         	equ     0x34    ;Byte to send to cathode 5

;Display bytes 1- Degrees F
Fcat1         	equ     0x35    ;Byte to send to cathode 1
Fcat2         	equ     0x36    ;Byte to send to cathode 2
Fcat3         	equ     0x37    ;Byte to send to cathode 3
Fcat4         	equ     0x38    ;Byte to send to cathode 4
Fcat5         	equ     0x39    ;Byte to send to cathode 5

;Display bytes 1- Degrees K
Kcat1         	equ     0x3a    ;Byte to send to cathode 1
Kcat2         	equ     0x3b    ;Byte to send to cathode 2
Kcat3         	equ     0x3c    ;Byte to send to cathode 3
Kcat4         	equ     0x3d    ;Byte to send to cathode 4
Kcat5         	equ     0x3e    ;Byte to send to cathode 5

;Display bytes 1- RH%
Rcat1         	equ     0x3f    ;Byte to send to cathode 1
Rcat2         	equ     0x40    ;Byte to send to cathode 2
Rcat3         	equ     0x41    ;Byte to send to cathode 3
Rcat4         	equ     0x42    ;Byte to send to cathode 4
Rcat5         	equ     0x43    ;Byte to send to cathode 5

;Display bytes Temp
xcat1         	equ     0x44    ;Byte to send to cathode 1
xcat2         	equ     0x45    ;Byte to send to cathode 2
xcat3         	equ     0x46    ;Byte to send to cathode 3
xcat4         	equ     0x47    ;Byte to send to cathode 4
xcat5         	equ     0x48    ;Byte to send to cathode 5

FahrM         	equ     0x49    ;Fahrenheit conversion register MSB
FahrL        	equ     0x4a    ;Fahrenheit conversion register LSB

;External sensor regs
DHT221			equ		0x4b	;Register for DHT data in LSB
DHT222			equ		0x4c	;Register for DHT data in 
DHT223			equ		0x4d	;Register for DHT data in 
DHT224			equ		0x4e	;Register for DHT data in
DHT225			equ		0x4f	;Register for DHT data in MSB

Fade1			equ		0x50	;Fade counter for digit 1
Fade2			equ		0x51	;Fade counter for digit 2
Fade3			equ		0x52	;Fade counter for digit 3
Fade4			equ		0x53	;Fade counter for digit 4
Fade5			equ		0x54	;Fade counter for digit 5

Dlay1			equ		0x55	;Loop delay counter for digit 1 - sets brightness
Dlay2			equ		0x56	;Loop delay counter for digit 2 - sets brightness
Dlay3			equ		0x57	;Loop delay counter for digit 3 - sets brightness
Dlay4			equ		0x58	;Loop delay counter for digit 4 - sets brightness
Dlay5			equ		0x59	;Loop delay counter for digit 5 - sets brightness
Dlay0			equ		0x5a	;Loop delay counter for off period - sets brightness

;Internal sensor regs
DHT111			equ		0x5b	;Register for DHT data in LSB
DHT112			equ		0x5c	;Register for DHT data in 
DHT113			equ		0x5d	;Register for DHT data in 
DHT114			equ		0x5e	;Register for DHT data in
DHT115			equ		0x5f	;Register for DHT data in MSB

DispDig			equ		0x60	;Byte to send to current display 0-11
Mick			equ		0x61	;Sub-tick
Tick			equ		0x62	;1/100 sec tick
Seck			equ		0x63	;Seconds
Mink			equ		0x64	;Minutes
Houk			equ		0x65	;Hours in 24h

HexAscMSN      	equ     0x66    ;Least significant digit to display
HexAscLSN      	equ     0x67    ;Most significant digit to display
DHTcount		equ		0x68	;DHT11 bits in counter
OldtempM		equ		0x69	;Last temp value MSB
OldtempL		equ		0x6a	;Last temp value LSB
SR1				equ		0x6b	;Shift register 1 for RNG 
SR2				equ		0x6c	;Shift register 2 for RNG
SR3				equ		0x6d	;Shift register 3 for RNG 
SR4				equ		0x6e	;Shift register 4 for RNG 
SR0				equ		0x6f	;temp working register for RNG 

IICM			equ		0x70	;IIC data shift register MSB
IICL			equ		0x71	;IIC data shift register LSB

Catcount		equ		0x72	;Cathode cleaning counter
HexAscIn		equ     0x73    ;Byte to be BCD'd
OldtempEM		equ		0x74	;Last EXT temp value MSB
OldtempEL		equ		0x75	;Last EXT temp value LSB

INTflags		equ		0x7a	;Software flag Bit 7 - Set every 1/50 sec loop 1
								;Software flag Bit 6 - Set every 1/50 sec loop 2
								;Software flag Bit 5 - Set every 1/50 sec loop 3
								;Software flag Bit 4 - Set every 1/50 sec loop 4
								;Software flag Bit 3 - Set every second
								;Software flag Bit 2 - Set every 6 seconds
								;Software flag Bit 1 - Set every counter interrupt 1/4000 sec
								;Software flag Bit 0 - 

DIGflags		equ		0x7b	;Software flag Bit 7 - Flicker on
								;Software flag Bit 6 - Ignore IR for 1 sec
								;Software flag Bit 5 - Light/dark
								;Software flag Bit 4 - Trigger effects on digit 5
								;Software flag Bit 3 - Trigger effects on digit 4
								;Software flag Bit 2 - Trigger effects on digit 3
								;Software flag Bit 1 - Trigger effects on digit 2
								;Software flag Bit 0 - Trigger effects on digit 1

DIGflags2		equ		0x7c	;Software flag Bit 7 - Initiate DHT start
								;Software flag Bit 6 - DHT started - cleared after 40 bits
								;Software flag Bit 5 - Valid temp set bit
								;Software flag Bit 4 - Valid RH set bit
								;Software flag Bit 3 - Indicates current cathode is blanked
								;Software flag Bit 2 - Cat cleaning enabled every 12 hours
								;Software flag Bit 1 - Ripplr direction
								;Software flag Bit 0 - Toggle random effects

DIGflags3		equ		0x7d	;Software flag Bit 7 - 
								;Software flag Bit 6 - 
								;Software flag Bit 5 - 
								;Software flag Bit 4 - 
								;Software flag Bit 3 - 
								;Software flag Bit 2 - Display ext sensor data if available
								;Software flag Bit 1 - External sensor enabled flag - ints will now read from RB2
								;Software flag Bit 0 - Valid data received from ext sensor

SELflags		equ		0x7e	;Software flag Bit 7 - Do not use
								;Software flag Bit 6 - Do not use
								;Software flag Bit 5 - Do not use
								;Software flag Bit 4 - Display off
								;Software flag Bit 3 - Temp in K displayed
								;Software flag Bit 2 - Temp in F displayed
								;Software flag Bit 1 - Temp in C displayed
								;Software flag Bit 0 - Do not use

#define		FMax		0x38 ;6f		;SMPS Frequency for 2 displays - set same as FMin if single tube module
#define		FMin		0x1b			;Half Fmax
#define		Ripple		0x09			;Ripple delay 14 to 4

;#########################################################################################################
;								START OF CODE
;#########################################################################################################

				org 0x00

		goto	Inity			;Reset vector

				org 0x04
		btfsc	PIR1,0
		goto	Timr1			;Timer 1 Interrupt - RTC

		btfsc	INTCON,0
		goto	DHTflag			;RB5 high interrupt - DHT bit start

		btfsc	INTCON,2
		goto	CallDHT			;Timer 0 Interrupt - DHT bit read

		retfie

;****************************************************************************************************

				org 0x010
;Initialise registers
		clrwdt
		BANKSEL	PORTA
Inity
		movlw	0x20
		movwf	FSR0L
		clrf	FSR0H
Init1
		clrf	INDF0
		incf	FSR0L,f
		btfss	FSR0L,7
		goto	Init1
		clrf	PORTA
		clrf	PORTB
;Set I/O pins
		BANKSEL	OSCCON
		movlw	b'01111011'
		movwf	OSCCON
		BANKSEL	TRISA
		movlw	b'00100001'
		movwf	TRISA
		movlw	b'00110000'
		movwf	TRISB
		movlw	b'10000000'
		movwf	OPTION_REG		;Timer 0 1:2 prescaler
;Enable ADC channels
		;movlw	b'01010000'		;Fosc/16
		;movwf	ADCON1
		BANKSEL	WPUA
		clrf	WPUA			;no pullups	
		clrf	WPUB			;no pullups	

;Set PWM
		BANKSEL	PR2
		movlw	FMax			;70khz start freq. 1c
		movwf	PR2
		BANKSEL	PIE1
		movlw	b'00000001'
		movwf	PIE1			;Enable timer 1 interrupts

;Set ADC controls
		BANKSEL	ANSELA
		clrf	ANSELA			;Weird DO fault?
		;bsf		ANSELA,0
		clrf	ANSELB

;------------------------------------------------------------

;Setup PWM
		BANKSEL	CCP1CON
		movlw	b'00000100'		;PWM timer steering
		movwf	CCPTMRS
		movlw	b'00000001'		;PWM steering
		movwf	PSTR1CON
		movwf	PSTR2CON
		movlw	b'00001100'		;PWM on
		movwf	CCP1CON
		movwf	CCP2CON
		bsf		PWM1CON,7		;autorestart
		bsf		PWM2CON,7		;autorestart
		movlw	FMin
		movwf	CCPR1L			;PWM1 ratio (set to half PR2)
		movlw	0x38
		movwf	CCPR2L			;PWM2 ratio (set to half PR2)

		BANKSEL	T4CON
;Setup Timer4
		movlw	0x6f			;36khz start freq. 1c
		movwf	PR4
		movlw	b'00000100'		;T4 on, 1:1 prescaler (clocks at 8mhz)
		movwf	T4CON

		BANKSEL	PORTA
;Setup Timer2
		movlw	b'00000100'		;T2 on, 1:1 prescaler (clocks at 8mhz)
		movwf	T2CON
;Setup Timer0
		movlw	0x01			;setup T0 for looong delay
		movwf	TMR0
;Setup timer 1 for RTC
		movlw	b'00000101'
		movwf	T1CON			;Set timer 1 no prescaler
		movlw	b'11000000'
		movwf	INTCON			;Interrupts enabled
;Set start conditions

		clrf	TMR1H
		clrf	TMR1L

;------------------------------------------------------------
;				Load dummy data/setup displays
;------------------------------------------------------------

		movlw	0x1b
		movwf	Ccat1
		movlw	0x1b
		movwf	Ccat2
		movlw	0x1b
		movwf	Ccat3
		movlw	0x05			;degrees C
		movwf	Ccat4
		movlw	0x0b
		movwf	Ccat5			;blank

		movlw	0x1b
		movwf	Fcat1
		movlw	0x1b
		movwf	Fcat2
		movlw	0x1b
		movwf	Fcat3
		movlw	0x0b			;blank
		movwf	Fcat4
		movlw	0x08
		movwf	Fcat5			;degrees F

		movlw	0x1b
		movwf	Kcat1
		movlw	0x1b
		movwf	Kcat2
		movlw	0x1b
		movwf	Kcat3
		movlw	0x01			;K
		movwf	Kcat4
		movlw	0x0b
		movwf	Kcat5			;T

		movlw	0x1b
		movwf	Rcat1
		movlw	0x1b
		movwf	Rcat2
		movlw	0x1b
		movwf	Rcat3
		movlw	0x06			;%
		movwf	Rcat4
		movlw	0x09;b
		movwf	Rcat5			;H

		call	loadSELflags	;Load saved display mode
		movwf	SELflags
		movlw	.200
		movwf	OldtempL
		movwf	OldtempEL
		bsf		DIGflags2,0
		btfss	SELflags,7
		bcf		DIGflags2,0
		call	LoadCats
		call	LoadCats
		call	brite
	;	bsf		DIGflags2,2;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
		movlw	.10
		movwf	Catcount
		goto	start

		org	0x7e0

loadSELflags					;Read eeprom data
		retlw	0x04

		org 0x100

;***************************************************************************************************************
;***************************************************************************************************************
;--------------------------------------------------------------------------------------------------------
start			;Refresh display loop - everything else on interrupts
;--------------------------------------------------------------------------------------------------------
;***************************************************************************************************************
;***************************************************************************************************************

		Call	load_1
		Call	load_2
		Call	load_3
		Call	load_4
		Call	load_5
		goto	start

;--------------------------------------------------------------------------------------------------------
load_1                        ;Load display data for digit 1 Fade1
;--------------------------------------------------------------------------------------------------------
;Check if fade enabled, reset counters, reset fade bit at 50% trigger fade bit 2

		movf	Old_cat1,w
		Call	Display_byte	;Set cathode for needed digit
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
		btfss	DIGflags2,3
		bsf		PORTB,1			;Anode on
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
		btfss	DIGflags,0		;Trigger fade?
		goto	load_1_1
		movlw	0x0f
		movwf	Fade1
		bcf		DIGflags,0
load_1_1
		incf	Fade1,f	
		decfsz	Fade1,f
		goto	load_1_2		;Fade active
		goto	load_1_3		;Fade NOT active
load_1_2
		movf   	Fade1,w
        movwf	DVAR2
d01
		movf	Dlay1,w
        movwf   DVAR
		clrwdt
d11
        decfsz  DVAR,F
        goto    d11
		call	checkk
        decfsz  DVAR2,F
        goto    d01


		movf	cat1,w
		andlw	0x0f

		btfsc	DIGflags,7
		movf	Fade1,w

		Call	Display_byte	;Set cathode for needed digit
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
		btfss	DIGflags2,3
		bsf		PORTB,1			;Anode on
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
		movf   	Fade1,w
		xorlw	0x0f
        movwf	DVAR2
        incf	DVAR2,f
d011
		movf	Dlay1,w
        movwf   DVAR
		clrwdt
d111
        decfsz  DVAR,F
        goto    d111
		call	checkk
        decfsz  DVAR2,F
        goto    d011
		btfss	DIGflags2,1
		bsf		DIGflags,1
		movlw	Ripple
		xorwf	Fade1,w
		btfss	STATUS,Z
		bcf		DIGflags,1
		decfsz	Fade1,f
		goto	load_1_4
		movf	cat1,w
		movwf	Old_cat1
		bcf		DIGflags2,1	
		goto	load_1_4

load_1_3
		movlw  	0x12
        movwf	DVAR2
d0111
		movf	Dlay1,w
        movwf   DVAR
		clrwdt
d1111
        decfsz  DVAR,F
        goto    d1111
		call	checkk
        decfsz  DVAR2,F
        goto    d0111
load_1_4
		btfss	cat1,4
		goto	load_1_5
		call	DPDP
		call	DPdel
load_1_5
		bcf		PORTB,1			;Anode off
		call	Catt			;Ghosting delay
		return

;--------------------------------------------------------------------------------------------------------
load_2                        ;Load display data for digit 2
;--------------------------------------------------------------------------------------------------------

		movf	Old_cat2,w
		Call	Display_byte	;Set cathode for needed digit
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
		btfss	DIGflags2,3
		bsf		PORTA,4			;Anode on
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
		btfss	DIGflags,1		;Trigger fade?
		goto	load_2_1
		movlw	0x0f
		movwf	Fade2
		bcf		DIGflags,1
load_2_1
		incf	Fade2,f	
		decfsz	Fade2,f
		goto	load_2_2		;Fade active
		goto	load_2_3		;Fade NOT active
load_2_2
		movf   	Fade2,w
        movwf	DVAR2
d02
		movf	Dlay2,w
        movwf   DVAR
		clrwdt
d12
        decfsz  DVAR,F
        goto    d12
		call	checkk
        decfsz  DVAR2,F
        goto    d02
		movf	cat2,w
		btfsc	DIGflags,7
		movf	Fade2,w
		Call	Display_byte	;Set cathode for needed digit
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
		btfss	DIGflags2,3
		bsf		PORTA,4			;Anode on
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
		movf   	Fade2,w
		xorlw	0x0f
        movwf	DVAR2
        incf	DVAR2,f
d012
		movf	Dlay2,w
        movwf   DVAR
		clrwdt
d112
        decfsz  DVAR,F
        goto    d112
		call	checkk
        decfsz  DVAR2,F
        goto    d012

		btfsc	DIGflags2,1
		goto	load_2_BW

		bsf		DIGflags,2
		movlw	Ripple
		xorwf	Fade2,w
		btfss	STATUS,Z
		bcf		DIGflags,2
		decfsz	Fade2,f
		goto	load_2_4
		movf	cat2,w
		movwf	Old_cat2
		goto	load_2_4

load_2_BW
		bsf		DIGflags,0
		movlw	Ripple
		xorwf	Fade2,w
		btfss	STATUS,Z
		bcf		DIGflags,0
		decfsz	Fade2,f
		goto	load_2_4
		movf	cat2,w
		movwf	Old_cat2
		goto	load_2_4

load_2_3
		movlw  	0x12
        movwf	DVAR2
d0112
		movf	Dlay2,w
        movwf   DVAR
		clrwdt
d1112
        decfsz  DVAR,F
        goto    d1112
		call	checkk
        decfsz  DVAR2,F
        goto    d0112
load_2_4
		btfss	cat2,4
		goto	load_2_5
		call	DPDP
		call	DPdel
load_2_5
		bcf		PORTA,4			;Anode off
		call	Catt			;Ghosting delay
		return

;--------------------------------------------------------------------------------------------------------
load_3                        ;Load display data for digit 3
;--------------------------------------------------------------------------------------------------------

		movf	Old_cat3,w
		Call	Display_byte	;Set cathode for needed digit
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
		btfss	DIGflags2,3
		bsf		PORTA,3			;Anode on
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
		btfss	DIGflags,2		;Trigger fade?
		goto	load_3_1
		movlw	0x0f
		movwf	Fade3
		bcf		DIGflags,2
load_3_1
		incf	Fade3,f	
		decfsz	Fade3,f
		goto	load_3_2		;Fade active
		goto	load_3_3		;Fade NOT active
load_3_2
		movf   	Fade3,w
        movwf	DVAR2
d03
		movf	Dlay3,w
        movwf   DVAR
		clrwdt
d13
        decfsz  DVAR,F
        goto    d13
		call	checkk
        decfsz  DVAR2,F
        goto    d03
		movf	cat3,w
		btfsc	DIGflags,7
		movf	Fade3,w
		Call	Display_byte	;Set cathode for needed digit
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
		btfss	DIGflags2,3
		bsf		PORTA,3			;Anode on
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
		movf   	Fade3,w
		xorlw	0x0f
        movwf	DVAR2
        incf	DVAR2,f
d013
		movf	Dlay3,w
        movwf   DVAR
		clrwdt
d113
        decfsz  DVAR,F
        goto    d113
		call	checkk
        decfsz  DVAR2,F
        goto    d013

		btfsc	DIGflags2,1
		goto	load_3_BW

		bsf		DIGflags,3
		movlw	Ripple
		xorwf	Fade3,w
		btfss	STATUS,Z
		bcf		DIGflags,3
		decfsz	Fade3,f
		goto	load_3_4
		movf	cat3,w
		movwf	Old_cat3
		goto	load_3_4

load_3_BW
		bsf		DIGflags,1
		movlw	Ripple
		xorwf	Fade3,w
		btfss	STATUS,Z
		bcf		DIGflags,1
		decfsz	Fade3,f
		goto	load_3_4
		movf	cat3,w
		movwf	Old_cat3
		goto	load_3_4


load_3_3
		movlw  	0x12
        movwf	DVAR2
d0113
		movf	Dlay3,w
        movwf   DVAR
		clrwdt
d1113
        decfsz  DVAR,F
        goto    d1113
		call	checkk
        decfsz  DVAR2,F
        goto    d0113
load_3_4
		btfss	cat3,4
		goto	load_3_5
		call	DPDP
		call	DPdel
load_3_5
		bcf		PORTA,3			;Anode off
		call	Catt			;Ghosting delay
		return

;--------------------------------------------------------------------------------------------------------
load_4                        ;Load display data for digit 4
;--------------------------------------------------------------------------------------------------------

		movf	Old_cat4,w
		Call	Display_byte	;Set cathode for needed digit
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
		btfss	DIGflags2,3
		bsf		PORTA,2			;Anode on
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;		
		btfss	DIGflags,3		;Trigger fade?
		goto	load_4_1
		movlw	0x0f
		movwf	Fade4
		bcf		DIGflags,3
load_4_1
		incf	Fade4,f	
		decfsz	Fade4,f
		goto	load_4_2		;Fade active
		goto	load_4_3		;Fade NOT active
load_4_2
		movf   	Fade4,w
        movwf	DVAR2
d04
		movf	Dlay4,w
        movwf   DVAR
		clrwdt
d14
        decfsz  DVAR,F
        goto    d14
		call	checkk
        decfsz  DVAR2,F
        goto    d04
		movf	cat4,w
		btfsc	DIGflags,7
		movf	Fade4,w
		Call	Display_byte	;Set cathode for needed digit

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
		btfss	DIGflags2,3
		bsf		PORTA,2			;Anode on
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
		movf   	Fade4,w
		xorlw	0x0f
        movwf	DVAR2
        incf	DVAR2,f
d014
		movf	Dlay4,w
        movwf   DVAR
		clrwdt
d114
        decfsz  DVAR,F
        goto    d114
		call	checkk
        decfsz  DVAR2,F
        goto    d014


		btfsc	DIGflags2,1
		goto	load_4_BW

		bsf		DIGflags,4
		movlw	Ripple
		xorwf	Fade4,w
		btfss	STATUS,Z
		bcf		DIGflags,4
		decfsz	Fade4,f
		goto	load_4_4
		movf	cat4,w
		movwf	Old_cat4
		goto	load_4_4

load_4_BW
		bsf		DIGflags,2
		movlw	Ripple
		xorwf	Fade4,w
		btfss	STATUS,Z
		bcf		DIGflags,2
		decfsz	Fade4,f
		goto	load_4_4
		movf	cat4,w
		movwf	Old_cat4
		goto	load_4_4

load_4_3
		movlw  	0x12
        movwf	DVAR2
d0114
		movf	Dlay4,w
        movwf   DVAR
		clrwdt
d1114
        decfsz  DVAR,F
        goto    d1114
		call	checkk
        decfsz  DVAR2,F
        goto    d0114
load_4_4
		bcf		PORTA,2			;Anode off
		call	Catt			;Ghosting delay
		return

;--------------------------------------------------------------------------------------------------------
load_5                        ;Load display data for digit 5
;--------------------------------------------------------------------------------------------------------

		movf	Old_cat5,w
		Call	Display_byte	;Set cathode for needed digit
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
		btfss	DIGflags2,3
		bsf		PORTA,7			;Anode on
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
		btfss	DIGflags,4		;Trigger fade?
		goto	load_5_1
		movlw	0x0f
		movwf	Fade5
		bcf		DIGflags,4
load_5_1
		incf	Fade5,f	
		decfsz	Fade5,f
		goto	load_5_2		;Fade active
		goto	load_5_3		;Fade NOT active
load_5_2
		movf   	Fade5,w
        movwf	DVAR2
d05
		movf	Dlay5,w
        movwf   DVAR
		clrwdt
d15
        decfsz  DVAR,F
        goto    d15
		call	checkk
        decfsz  DVAR2,F
        goto    d05
		movf	cat5,w
		btfsc	DIGflags,7
		movf	Fade5,w
		Call	Display_byte	;Set cathode for needed digit
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
		btfss	DIGflags2,3
		bsf		PORTA,7			;Anode on
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
		movf   	Fade5,w
		xorlw	0x0f
        movwf	DVAR2
        incf	DVAR2,f
d015
		movf	Dlay5,w
        movwf   DVAR
		clrwdt
d115
        decfsz  DVAR,F
        goto    d115
		call	checkk
        decfsz  DVAR2,F
        goto    d015

		btfsc	DIGflags2,1
		goto	load_5_BW

		decfsz	Fade5,f
		goto	load_5_4
		movf	cat5,w
		movwf	Old_cat5
		bcf		DIGflags,7
		goto	load_5_4

load_5_BW
		bsf		DIGflags,3
		movlw	Ripple
		xorwf	Fade5,w
		btfss	STATUS,Z
		bcf		DIGflags,3
		decfsz	Fade5,f
		goto	load_5_4
		movf	cat5,w
		movwf	Old_cat5
		goto	load_5_4


		decfsz	Fade5,f
		goto	load_5_4
		movf	cat5,w
		movwf	Old_cat5
		bcf		DIGflags,7
		goto	load_5_4

load_5_3
		movlw  	0x12
        movwf	DVAR2
d0115
		movf	Dlay5,w
        movwf   DVAR
		clrwdt
d1115
        decfsz  DVAR,F
        goto    d1115
		call	checkk
        decfsz  DVAR2,F
        goto    d0115
load_5_4
		bcf		PORTA,7			;Anode off
		call	Catt			;Ghosting delay
		return

;--------------------------------------------------------------------------------------------------------
checkk							;Check INTflags
;--------------------------------------------------------------------------------------------------------

		btfsc	INTflags,0		;Check flag to call DHT in
		call	CallDHT
		btfsc	INTflags,1		;Check flag to call clock etc
		call	CallInt
		btfsc	INTflags,7		;Check flag to call HV etc.
		call	Call501
		btfsc	INTflags,6		;Check flag to call HV etc.
		call	Call502
		btfsc	INTflags,5		;Check flag to call HV etc.
		call	Call503
		btfsc	INTflags,4		;Check flag to call HV etc.
		call	Call504
		btfsc	INTflags,3		;Check flag to call once a second
		call	Call1
		btfsc	INTflags,2		;Check flag to call once 6 seconds
		call	Call6
		return

;--------------------------------------------------------------------------------------------------------
brite							;Setup delay loop values
;--------------------------------------------------------------------------------------------------------

		;btfsc	DIGflags,5
		;goto	briter
		movlw	0xbf
		movwf	Dlay1
		movwf	Dlay2
		movwf	Dlay3
		movlw	0x76
		movwf	Dlay4
		movwf	Dlay5
		movlw	0x10
		movwf	Dlay0
		BANKSEL	PR2
		movlw	FMax			;70khz start freq. 1c
		movwf	PR2
		BANKSEL	PORTA
		return
briter
		;movlw	0x15
		;movwf	Dlay1
		;movwf	Dlay2
		;movwf	Dlay3
		;movwf	Dlay4
		;movwf	Dlay5
		BANKSEL	PR2
		movlw	0xff			;15khz start freq. 1c
		movwf	PR2
		BANKSEL	PORTA
		return

;--------------------------------------------------------------------------------------------------------
Timr1							;Timer 1 interrupt, set 1/4000 flag
;--------------------------------------------------------------------------------------------------------

								;Reload counter for next interrupt
		bsf		INTflags,1
		bcf		PIR1,0 			;clear timer 1 int
		retfie

;--------------------------------------------------------------------------------------------------------
ClockInc						;Increment counters for RTC every 4000/sec
;-------------------------------------------------------------------------------------------------------

		movlw	0xfe			;high byte timer 1
		movwf	TMR1H
		movlw	0x21			;low byte 0b
		movwf	TMR1L
		incf	Mick,f
		movlw	.50
		xorwf	Mick,w
		btfss	STATUS,Z
		goto	mainsexit
		clrf	Mick
increment_tick					;Reaches here 100 times/sec
		bsf		SR0, 7			;Random Number gen - output in SR1
		btfss	SR4, 7
		bcf		SR0, 7	
		btfsc	SR4, 5
		comf	SR0, f
		btfsc	SR4, 1
		comf	SR0, f
		btfsc	SR4, 0
		comf	SR0, f
		movlw	0xff
		xorwf	SR0,f
		rlf		SR0	,f			;rotate bit 0 into carry	
		rlf		SR1, f	
		rlf		SR2, f
		rlf		SR3, f
		rlf		SR4, f	
		btfsc	Tick,1
		goto	tick_23
		btfsc	Tick,0
		goto	tick_1
		bsf		INTflags,7		;Set 1/25 sec flag
		goto	tick_0
tick_1
		bsf		INTflags,6		;Set 1/25 sec flag
		goto	tick_0
tick_23
		btfsc	Tick,0
		goto	tick_3
		bsf		INTflags,5		;Set 1/25 sec flag
		goto	tick_0
tick_3
		bsf		INTflags,4		;Set 1/25 sec flag
tick_0
		incf	Tick,f
		movlw	.120
		xorwf	Tick,w
		btfss	STATUS,Z
		goto	mainsexit
		clrf	Tick
increment_secs
		incf	Seck,f
		bsf		INTflags,3		;Flag second rollover
		movlw	.2
		xorwf	Seck,w
		btfss	STATUS,Z
		goto	mainsexit
		clrf	Seck
increment_min					;Every 10 seconds
		incf	Mink,f
		bsf		INTflags,2
		movlw	.200
		xorwf	Mink,w
		btfss	STATUS,Z
		goto	mainsexit
		clrf	Mink
increment_hour					;Every 10 minutes here
		incf	Houk,f
		movlw	.12
		xorwf	Houk,w
		btfss	STATUS,Z
		goto	mainsexit
		bsf		DIGflags2,2
		movlw	.11
		movwf	Catcount
		clrf	Houk
mainsexit						;Reload counter for next interrupt
		retfie

;--------------------------------------------------------------------------------------------------------
CallInt							;Run on timer interrupt, from main program loop - after int serviced.
;--------------------------------------------------------------------------------------------------------

		call	ClockInc		;Increment clock tick
		bcf		INTflags,1		;Finished, clear flag until next time
		return

;--------------------------------------------------------------------------------------------------------
Call501							;Run 25 times a sec, from main program loop.
;--------------------------------------------------------------------------------------------------------


		btfss	SELflags,4		;Has HV been switched off?;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
		goto	Call501b
		BANKSEL	CCPR1L			;Yes, shut off PWM
		movlw	0x0f
		movwf	CCPR1L
		BANKSEL	PORTA
Call501b



		BANKSEL	T4CON
		movlw	0x6f			;Switch on IR LED
		movwf	PR4

;DHT11 read? - set up start condition

		btfss	DIGflags2,7
		goto	Call501a
		BANKSEL	TRISA
		bcf		TRISB,5			;Set pin to output INT
		bcf		TRISB,2			;Set pin to output EXT
		BANKSEL	PORTA
		bcf		PORTB,5			;Pull low for start INT

		bcf		PORTB,2			;Pull low for start EXT
		bcf		DIGflags3,0		;clear ext sensor detected bit

Call501a
		BANKSEL	PORTA

		bcf		INTflags,7		;Finished, clear flag until next time
		return

;--------------------------------------------------------------------------------------------------------
Call502							;Run 25 times a sec, from main program loop.
;--------------------------------------------------------------------------------------------------------

		btfsc	PORTB,4			;Is the IR LED being reflected?
		clrf	IRcount			;No, reset counter
		incf	IRcount,f		;Yes, increment success counter

		btfss	SELflags,4		;Has HV been switched off?;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
		goto	Call502b
		BANKSEL	CCPR1L			;Yes, shut off PWM
		movlw	0x00
		movwf	CCPR1L
		BANKSEL	PORTA

Call502b
		BANKSEL	T4CON
		movlw	0x00			;Switch off IR LED
		movwf	PR4
		BANKSEL	PORTA

		bcf		INTflags,6		;Finished, clear flag until next time
		return

;--------------------------------------------------------------------------------------------------------
Call503							;Run 25 times a sec, from main program loop.
;--------------------------------------------------------------------------------------------------------

;DHT11 read? - set up start condition

		btfss	DIGflags2,7
		goto	Call5030
		BANKSEL	PORTA
		bsf		PORTB,5			;Pull high

		BANKSEL	TRISA
		bsf		TRISB,5			;Set pin to input
		bcf		DIGflags2,7		;clear start condition
		clrf	DHT111
		clrf	DHT112
		clrf	DHT113
		clrf	DHT114
		clrf	DHT115

		clrf	DHT221
		clrf	DHT222
		clrf	DHT223
		clrf	DHT224
		clrf	DHT225


;Setup interrupts for falling edge pin

		BANKSEL	IOCBP
		clrf	IOCBF			;enable rising edge interrupts on RB5
		bsf		IOCBP,5
		BANKSEL	PORTA
		bsf		INTCON,3
		movlw	.41				;Read 40 bits plus start bit
		movwf	DHTcount		;set number of bits
		bsf		DIGflags2,6		;set read bits condition
		bcf		INTCON,5		;Disable timer 0 interrupt
		movlw	0x01			;setup T0 for looong delay
		movwf	TMR0
		bcf		INTCON,2		;Clear timer 0 interrupt flag


;;;;;;;;;;;;;;;;;;;;;;;;;;;;

Call5030
		BANKSEL	PORTA
		btfss	IRcount,3
		goto	Call503a		;IR count not high enough to trigger 'on'
		clrf	IRcount
		btfsc	DIGflags,6		;IR ignore flag set?
		goto	Call503a
		clrf	DispCyc
		lslf	SELflags,f		;IR switch triggered, inc display mode
		btfsc	SELflags,5		
		bsf		SELflags,1
		call	LoadCats		;Transfer newly selected data to display registers
		clrf	Seck			;Reset second counter - allows at least 1 second before retrigger
		bsf		DIGflags,6		;Ignore new IR triggers for 1 second
		bcf		DIGflags,7
		btfsc	DIGflags2,0		;RND enable toggle
		bsf		DIGflags,7
		bcf		SELflags,7
		btfsc	DIGflags2,0		;RND enable toggle
		bsf		SELflags,7
		call	SaveData		;save new selection in eeprom

		btfss	SELflags,4		;Has HV been switched off?
		goto	Call503b
		BANKSEL	CCPR1L			;Yes, shut off PWM
		movlw	0x00
		movwf	CCPR1L
		BANKSEL	PORTA

		movlw	0x01
		xorwf	DIGflags2,f		;RND enable toggle
		goto	Call503a
Call503b
		BANKSEL	CCPR1L			;No, Switch on PWM
		movlw	FMin
		movwf	CCPR1L
		BANKSEL	PORTA
Call503a
		bcf		INTflags,5		;Finished, clear flag until next time
		return

;--------------------------------------------------------------------------------------------------------
Call504							;Run 25 times a sec, from main program loop.
;--------------------------------------------------------------------------------------------------------
;DHT11 read? - if still enabled there is an error

		btfss	DIGflags2,6
		goto	Call5040
		bsf		PORTB,5			;Pull high
		;bsf		PORTB,2			;Pull high
		BANKSEL	TRISA
		bcf		PORTB,5			;Set pin to output
		bsf		PORTB,2			;Set pin to input
		BANKSEL	PORTA
		bcf		DIGflags2,7		;clear start condition
		bcf		DIGflags2,6		;clear read condition

;code to reset ints
		bcf		INTCON,5		;Disable timer 0 interrupt
		movlw	0x01			;setup T0 for looong delay
		movwf	TMR0
		bcf		INTCON,2		;Clear timer 0 interrupt flag
		BANKSEL	IOCBP
		clrf	IOCBF			;disable rising edge interrupts on RB5
		bcf		IOCBP,5
		bcf		IOCBP,2
		BANKSEL	PORTA
		bcf		DIGflags3,1		;Reset int sensor flag

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
Call5040
		btfsc	DIGflags2,4		;Has DHT11 been read? - if so go do IIC read
		call	IICread
		btfsc	DIGflags2,5
		call	Tempcon			;Valid temp result, convert into other scales
	

;flag ext data
		btfss	DIGflags3,0	
		goto	Call5041
		btfsc	PORTA,0
		goto	Call5041
		btfss	DIGflags3,2	
		goto	Call5041
;Call5042
		bsf		Ccat1,4
		bsf		Fcat1,4
		bsf		Rcat2,4
		bsf		Kcat1,4


Call5041
		btfss	PORTB,4			;Is the IR sensor receiving?
		clrf	IRcount			;Yes, reset counter, the LED is off
		incf	IRcount,f		;No, increment success counter.
		bcf		INTflags,4		;Finished, clear flag until next time
		return

;--------------------------------------------------------------------------------------------------------
Call1							;Run once a sec, from main program loop - display tree
;--------------------------------------------------------------------------------------------------------

		call	brite			;Set display brightness
		incf	DispCyc,f

		movlw	.4				;Seconds until clear display 1
		xorwf	DispCyc,w
		btfss	STATUS,Z
		goto	Call1a
		call	LoadBB
		bsf		DIGflags2,7;;;;;;;;;;;;;;;;;;
		bcf		DIGflags3,2		;disable ext display if availabe
Call1a
		movlw	.5				;Seconds until display RH
		xorwf	DispCyc,w
		btfss	STATUS,Z
		goto	Call1b
		btfsc	DIGflags2,0		;RND enabled?
		call	RandomDisp
		btfss	DIGflags2,0		;RND enabled?
		call	LoadR
Call1b
		movlw	.8				;Seconds until clear display 1
		xorwf	DispCyc,w
		btfss	STATUS,Z
		goto	Call1c
		call	LoadBB
		bsf		DIGflags2,7;;;;;;;;;
		bcf		DIGflags3,2		;disable ext display if availabe
Call1c
		movlw	.9				;Seconds until display RH
		xorwf	DispCyc,w
		btfss	STATUS,Z
		goto	Call1d
		call	LoadCats
		btfsc	DIGflags2,0		;RND enabled?
		call	RandomDisp10

Call1d
		;movlw	.12				;Seconds until repeat loop
		;xorwf	DispCyc,w
		;btfss	STATUS,Z
		;goto	Call1e
		;clrf	DispCyc




		movlw	.12				;Seconds until clear display 1
		xorwf	DispCyc,w
		btfss	STATUS,Z
		goto	Call1e
		call	LoadBB
		bsf		DIGflags2,7;;;;;;;;;;;;;;;;;;
		bsf		DIGflags3,2		;enable ext display if availabe
Call1e
		movlw	.13				;Seconds until display RH
		xorwf	DispCyc,w
		btfss	STATUS,Z
		goto	Call1f
		btfsc	DIGflags2,0		;RND enabled?
		call	RandomDisp
		btfss	DIGflags2,0		;RND enabled?
		call	LoadR
Call1f
		movlw	.16				;Seconds until clear display 1
		xorwf	DispCyc,w
		btfss	STATUS,Z
		goto	Call1g
		call	LoadBB
		bsf		DIGflags2,7;;;;;;;;;
		bsf		DIGflags3,2		;enable ext display if availabe
Call1g
		movlw	.17				;Seconds until display RH
		xorwf	DispCyc,w
		btfss	STATUS,Z
		goto	Call1h
		call	LoadCats
		btfsc	DIGflags2,0		;RND enabled?
		call	RandomDisp10

Call1h
		movlw	.20				;Seconds until repeat loop
		xorwf	DispCyc,w
		btfss	STATUS,Z
		goto	Call1i
		clrf	DispCyc



Call1i

		bcf		DIGflags,6
		bcf		INTflags,3
		return

;--------------------------------------------------------------------------------------------------------
Call6							;Run once every 6 sec, from main program loop.
;--------------------------------------------------------------------------------------------------------

		bcf		DIGflags2,5	
		bcf		DIGflags2,4	
		bcf		INTflags,2
		incf	Catcount,f
		decfsz	Catcount,f
		goto	Call61
		bcf		DIGflags2,2
Call61
		decf	Catcount,f
		return

;--------------------------------------------------------------------------------------------------------
Tempcon							;Convert C to F and K
;--------------------------------------------------------------------------------------------------------

		bcf		INTCON,7

		btfss	DIGflags3,0	
		goto	TempconI		;no external data, goto internal
		btfsc	PORTA,0			;RA0 high, use ext always
		goto	Tempcon42
		btfss	DIGflags3,2		;RA0 low, use when flagged
		goto	TempconI		;Don't use external data, goto internal
Tempcon42
;load ext sensor data into internal sensor registers

		movf	DHT225,w
		movwf	DHT115
		movf	DHT224,w
		movwf	DHT114
		movf	DHT223,w
		movwf	DHT113
		movf	DHT222,w
		movwf	DHT112
		movf	DHT221,w
		movwf	DHT111


								;Temp smoothing for external data
		;movf	OldtempEM,w	
		;movwf	FahrM
		;movf	OldtempEL,w		;x15, Add last temp and divide by 16
		;movwf	FahrL
		;lslf	FahrL,f
		;rlf		FahrM,f
		;movf	OldtempEL,w
		;addwf	FahrL,f
		;btfsc	STATUS,C
		;incf	FahrM,f
		;movf	OldtempEM,w	
		;addwf	FahrM,f			;x3
		;lslf	FahrL,f
		;rlf		FahrM,f
		;movf	OldtempEL,w
		;addwf	FahrL,f
		;btfsc	STATUS,C
		;incf	FahrM,f
		;movf	OldtempEM,w	
		;addwf	FahrM,f			;x7
		;lslf	FahrL,f
		;rlf		FahrM,f
		;movf	OldtempEL,w
		;addwf	FahrL,f
		;btfsc	STATUS,C
		;incf	FahrM,f
		;movf	OldtempEM,w	
		;addwf	FahrM,f			;x15

		;movf	FahrL,w
		;addwf	DHT112,f
		;btfsc	STATUS,C
		;incf	FahrM,f
		;movf	FahrM,w
		;addwf	DHT113,f		;Plus 1
								;Divide by 16
		;lsrf	DHT113,f
		;rrf		DHT112,f
		;lsrf	DHT113,f
		;rrf		DHT112,f
		;lsrf	DHT113,f
		;rrf		DHT112,f
		;lsrf	DHT113,f
		;rrf		DHT112,f
		;movf	DHT112,w
		;movwf	OldtempEL
		;movf	DHT113,w
		;movwf	OldtempEM
		goto	TempconR		;finished, go process data



TempconI

								;Temp smoothing
		movf	OldtempM,w	
		movwf	FahrM
		movf	OldtempL,w		;x31, Add last temp and divide by 32
		movwf	FahrL
		lslf	FahrL,f
		rlf		FahrM,f
		movf	OldtempL,w
		addwf	FahrL,f
		btfsc	STATUS,C
		incf	FahrM,f
		movf	OldtempM,w	
		addwf	FahrM,f			;x3
		lslf	FahrL,f
		rlf		FahrM,f
		movf	OldtempL,w
		addwf	FahrL,f
		btfsc	STATUS,C
		incf	FahrM,f
		movf	OldtempM,w	
		addwf	FahrM,f			;x7
		lslf	FahrL,f
		rlf		FahrM,f
		movf	OldtempL,w
		addwf	FahrL,f
		btfsc	STATUS,C
		incf	FahrM,f
		movf	OldtempM,w	
		addwf	FahrM,f			;x15
		;lslf	FahrL,f
		;rlf		FahrM,f
		;movf	OldtempL,w
		;addwf	FahrL,f
		;btfsc	STATUS,C
		;incf	FahrM,f
		;movf	OldtempM,w	
		;addwf	FahrM,f			;x31

		movf	FahrL,w
		addwf	DHT112,f
		btfsc	STATUS,C
		incf	FahrM,f
		movf	FahrM,w
		addwf	DHT113,f		;Plus 1
								;Divide by 32
		;lsrf	DHT113,f
		;rrf		DHT112,f
		lsrf	DHT113,f
		rrf		DHT112,f
		lsrf	DHT113,f
		rrf		DHT112,f
		lsrf	DHT113,f
		rrf		DHT112,f
		lsrf	DHT113,f
		rrf		DHT112,f
		movf	DHT112,w
		movwf	OldtempL
		movf	DHT113,w
		movwf	OldtempM

TempconR						;int/ext done, continue with data

;Setup RH display data

		movlw	0x0b
		movwf	Rcat1
		movf	DHT115,w
		movwf	HexAscIn
		call	Hex2BCD
		movf	HexAscMSN,w
		movwf	Rcat2
		movf	HexAscLSN,w
		movwf	Rcat3


		movf	DHT113,w
		movwf	DHT223
		movf	DHT112,w
		movwf	DHT222			;preserve registers for later use


								;Multiply result in DHT 112,113 by 28.8 1.8

		movf	DHT113,w
		movwf	FahrM
		movf	DHT112,w
		movwf	FahrL

		lslf	FahrL,f	
		rlf		FahrM,f
		call	add16
		lslf	FahrL,f	
		rlf		FahrM,f
		call	add16
		lslf	FahrL,f	
		rlf		FahrM,f
		lslf	FahrL,f	
		rlf		FahrM,f		;x28 now in Fahr regs


		lsrf	DHT113,f
		rrf		DHT112,f
		call	add16			;plus .5 = 28.5
		lsrf	DHT113,f
		rrf		DHT112,f
		call	add16			;plus .25 = 28.75
		lsrf	DHT113,f
		rrf		DHT112,f
		lsrf	DHT113,f
		rrf		DHT112,f
		lsrf	DHT113,f
		rrf		DHT112,f	
		call	add16			;plus .0312 = 28.7812
		lsrf	DHT113,f
		rrf		DHT112,f
		lsrf	DHT113,f
		rrf		DHT112,f
		call	add16			;plus .0078 = 28.8

		lsrf	FahrM,f	
		rrf		FahrL,f
		lsrf	FahrM,f	
		rrf		FahrL,f
		lsrf	FahrM,f	
		rrf		FahrL,f
		lsrf	FahrM,f	
		rrf		FahrL,f			;now divide by 16 = x1.8
		incf	FahrL,f

	
TempconF						;Convert F value to BCD, decide if DP is needed (12.3 or 123.).

		movlw	.64				;Add 320 to total
		addwf	FahrL,f
		btfsc	STATUS,C
		incf	FahrM,f	
		incf	FahrM,f			;Add the other 256
		call	Div1h
		movf	FahrM,w	
		movwf	HexAscIn
		call	Hex2BCD
		movf	HexAscLSN,w
		movwf	xcat2
		movf	HexAscMSN,w
		movwf	xcat1
		movf	FahrL,w
		movwf	HexAscIn
		call	Hex2BCD
		movf	HexAscLSN,w
		movwf	xcat4
		movf	HexAscMSN,w
		movwf	xcat3		
		incf	xcat1,f
		decfsz	xcat1,f
		goto	Tempcon2		;MS digit is not zero, no decimal.

		movf	xcat2,w
		movwf	Fcat1
		movf	xcat3,w
		movwf	Fcat2
		movf	xcat4,w
		movwf	Fcat3
		bsf		Fcat3,4			;DP on
		goto	Tempcon3

Tempcon2						;MS digit is not zero, no decimal.
		movf	xcat1,w
		movwf	Fcat1
		movf	xcat2,w
		movwf	Fcat2
		movf	xcat3,w
		movwf	Fcat3

Tempcon3
								;Load Celsius data
		movf	DHT223,w
		movwf	FahrM
		movf	DHT222,w
		movwf	FahrL
		call	Div1h			;Prepare 2 BCD bytes

		movf	FahrL,w
		movwf	HexAscIn
		call	Hex2BCD
		movf	HexAscMSN,w
		movwf	Ccat2
		movf	HexAscLSN,w
		movwf	Ccat3
		movf	FahrM,w
		movwf	HexAscIn
		call	Hex2BCD
		movf	HexAscLSN,w
		movwf	Ccat1
		bsf		Ccat3,4			;DP on
		incf	Ccat1,f
		decfsz	Ccat1,f
		goto	Tempcon1
		movlw	0x0b
		movwf	Ccat1			;Value is 0, blank digit

Tempcon1
								;Load Kelvin data
		movf	DHT223,w
		movwf	FahrM
		movf	DHT222,w
		movwf	FahrL

		movlw	.172			;Add 17.2 (closest available to 273.16 is 273.2)
		addwf	FahrL,f
		btfsc	STATUS,C
		incf	FahrM,f
		movlw	.10				;the other 256*10
		addwf	FahrM,f

		call	Div1h			;Prepare 2 BCD bytes
		movf	FahrL,w
		movwf	HexAscIn
		call	Hex2BCD
		movf	HexAscMSN,w
		movwf	Kcat3
		movf	FahrM,w
		movwf	HexAscIn
		call	Hex2BCD
		movf	HexAscMSN,w
		movwf	Kcat1
		movf	HexAscLSN,w
		movwf	Kcat2

		bsf		INTCON,7
		bcf		DIGflags2,5
		return

;Divide by 100 to produce 2 BCD bytes

Div1h	
		clrwdt						
		clrf	xcat2
Div1h1
		movlw	.100
		subwf	FahrL,f
		btfss	STATUS,C
		goto	Div1h2		;borrow
Div1h3
		incf	xcat2,f
		goto	Div1h1

Div1h2						;Borrow from MSB
		movlw	.1
		subwf	FahrM,f
		btfsc	STATUS,C
		goto	Div1h3
		incf	FahrM,f
		goto	Div1hfail2

Div1hfail2
		movlw	.100		;restore MSB
		addwf	FahrL,f	
		movf	xcat2,w
		movwf	FahrM
		return

add16	
		movf	DHT112,w
   		addwf   FahrL,f 
		btfsc	STATUS,C
		incf	FahrM,f
		movf	DHT113,w
		addwf	FahrM,f
		return

;--------------------------------------------------------------------------------------------------------
IICread							;Read temp from LM75 type device
;--------------------------------------------------------------------------------------------------------

		bcf		INTCON,7		;Do Not Disturb
		BANKSEL	PORTA			;Setup bus start
		bsf		PORTB,2			;SDA high
		bsf		PORTB,5			;SCL high
		BANKSEL	TRISA
		bcf		PORTB,2			;SDA out
		bcf		PORTB,5			;SCL out
		BANKSEL	PORTA
		clrf	IICM
		clrf	IICL
		call	lildel
		call	lildel
		call	lildel
		call	lildel
								;Send start bit
		bcf		PORTB,2			;SDA low
		call	lildel
		bcf		PORTB,5			;SCL low
;bit6 1
		bsf		PORTB,2			;SDA high
		call	lildel
		bsf		PORTB,5			;SCL high
		call	lildel
		bcf		PORTB,5			;SCL low
		nop
;bit5 0
		bcf		PORTB,2			;SDA high
		call	lildel
		bsf		PORTB,5			;SCL high
		call	lildel
		bcf		PORTB,5			;SCL low
		nop
;bit4 0
		bcf		PORTB,2			;SDA low
		call	lildel
		bsf		PORTB,5			;SCL high
		call	lildel
		bcf		PORTB,5			;SCL low
		nop
;bit3 1
		bsf		PORTB,2			;SDA high
		call	lildel
		bsf		PORTB,5			;SCL high
		call	lildel
		bcf		PORTB,5			;SCL low
		nop
;bit2 0
		bcf		PORTB,2			;SDA low
		call	lildel
		bsf		PORTB,5			;SCL high
		call	lildel
		bcf		PORTB,5			;SCL low
		nop
;bit1 0
		bcf		PORTB,2			;SDA low
		call	lildel
		bsf		PORTB,5			;SCL high
		call	lildel
		bcf		PORTB,5			;SCL low
		nop
;bit0 0
		bcf		PORTB,2			;SDA low
		call	lildel
		bsf		PORTB,5			;SCL high
		call	lildel
		bcf		PORTB,5			;SCL low
		nop
;r/w 1
		bsf		PORTB,2			;SDA high
		call	lildel
		bsf		PORTB,5			;SCL high
		call	lildel
		bcf		PORTB,5			;SCL low
		nop
		bcf		PORTB,2			;SDA low
;Set in
		BANKSEL	TRISA
		bsf		PORTB,2			;SDA in
		BANKSEL	PORTA
;ACK
		call	lildel
		bsf		PORTB,5			;SCL high
		call	lildel
		bcf		PORTB,5			;SCL low
		call	lildel
		call	lildel
		movlw	.8
		movwf	DVAR
IICin1							;read first byte into IICM
		lslf	IICM,f
		bsf		PORTB,5			;SCL high
		call	lildel
		bsf		IICM,0
		btfss	PORTB,2	
		bcf		IICM,0	
		bcf		PORTB,5			;SCL low
		call	lildel
		decfsz	DVAR,f
		goto	IICin1
		bcf		PORTB,2			;SDA low
;Set out
		BANKSEL	TRISA
		bcf		PORTB,2			;SDA out
		BANKSEL	PORTA
;ACK
		call	lildel
		bsf		PORTB,5			;SCL high
		call	lildel
		bcf		PORTB,5			;SCL low
;Set in
		BANKSEL	TRISA
		bsf		PORTB,2			;SDA in
		BANKSEL	PORTA
		call	lildel
		call	lildel
		movlw	.8
		movwf	DVAR
IICin2							;read second byte into IICL
		lslf	IICL,f
		bsf		PORTB,5			;SCL high
		call	lildel
		bsf		IICL,0
		btfss	PORTB,2	
		bcf		IICL,0
		bcf		PORTB,5			;SCL low
		call	lildel	
		decfsz	DVAR,f
		goto	IICin2
		bsf		PORTB,2			;SDA high
;Set out
		BANKSEL	TRISA
		bcf		PORTB,2			;SDA out
		BANKSEL	PORTA
;NACK
		call	lildel
		bsf		PORTB,5			;SCL high
		call	lildel
		bcf		PORTB,5			;SCL low
;STOP
		call	lildel
		bcf		PORTB,2			;SDA low
		call	lildel
		bsf		PORTB,5			;SCL high
		call	lildel
		bsf		PORTB,2			;SDA high

		bcf		DIGflags2,4		;IIC done

		btfsc	IICL,0			;Is there valid data from the IIC device?;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
		goto	IICexit			;No. Exit and use the DHT data

;Check if negative, set to zero if so
		btfsc	IICM,7
		clrf	IICL
		btfsc	IICM,7
		clrf	IICM

;multiply by 1.25 to simulate decimal data and save in DHT112,3

		movf	IICL,w
		movwf	DHT112
		movwf	FahrL
		movf	IICM,w
		movwf	DHT113
		movwf	FahrM
		lsrf	IICM,f
		rrf		IICL,f
		lsrf	IICM,f
		rrf		IICL,w			;Divide by 4
		addwf	DHT112,f
		btfsc	STATUS,C
		incf	IICM,f
		movf	IICM,w	
		addwf	DHT113,f
		bsf		DIGflags2,5		;Set Temp data read

;Rotate to place LSB at start of DHT112

		lsrf	DHT113,f
		rrf		DHT112,f
		lsrf	DHT113,f
		rrf		DHT112,f
		lsrf	DHT113,f
		rrf		DHT112,f
		lsrf	DHT113,f
		rrf		DHT112,f
		lsrf	DHT113,f
		rrf		DHT112,f


IICexit
		bsf		INTCON,7
		return

lildel
		nop
		nop
		nop
		nop
		nop
		nop
		nop
		nop
		nop
		nop
		nop
		nop
		nop
		nop
		nop
		nop
		nop
		nop
		nop
		return

;--------------------------------------------------------------------------------------------------------
DHTflag							;Mark interrupt flag for DHT data
;--------------------------------------------------------------------------------------------------------

		bcf		INTCON,3
		BANKSEL	IOCBP
		clrf	IOCBF			;clear int flags
		BANKSEL	PORTA
		movlw	0xb0			;setup T0 for 50us delay
		movwf	TMR0
		bcf		INTCON,2		;Clear timer 0 interrupt flag
		bsf		INTCON,5		;Enable timer 0 interrupt
		retfie

;--------------------------------------------------------------------------------------------------------
CallDHT							;Read data from sensor
;--------------------------------------------------------------------------------------------------------

		bcf		INTCON,2		;Clear timer 0 interrupt flag
		bcf		INTCON,5		;Disable timer 0 interrupt
		movlw	0x01			;setup T0 for looong delay
		movwf	TMR0
		btfss	DIGflags2,6		;check read condition
		retfie

		btfsc	DIGflags3,1		;External read?
		goto	CallDHTX		;Yes

		rlf		DHT111,f		;Checksum haha
		rlf		DHT112,f		;Temp fraction (unused in DHT11)
		rlf		DHT113,f		;Temp byte
		rlf		DHT114,f		;RH fraction (unused in DHT11)
		rlf		DHT115,f		;RH byte

		bcf		DHT111,0
		btfsc	PORTB,5
		bsf		DHT111,0

		bsf		INTCON,3
		decfsz	DHTcount,f
		goto	CallDHTexit
		bcf		INTCON,3

		bcf		DIGflags2,7		;clear start condition
		bcf		DIGflags2,6		;clear read condition

;Checksum test
		movf	DHT115,w
		movwf	DHTcount
		movf	DHT114,w
		addwf	DHTcount,f
		movf	DHT113,w
		addwf	DHTcount,f
		movf	DHT112,w
		addwf	DHTcount,w
		xorwf	DHT111,w
		btfss	STATUS,Z
		goto	Fail_ed			;Failed checksum, ignore data
		bsf		DIGflags2,4		;Checksum OK, Set RH data read
		bsf		DIGflags2,5		;Set Temp data read


		incf	DHT112,f
		decfsz	DHT112,f
		goto	itsa22i			;Not zero so assume it's a DHT22
		incf	DHT114,f
		decfsz	DHT114,f
		goto	itsa22i			;Not zero so assume it's a DHT22
		goto	itsan11i		;Both zero so assume it's a DHT11


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;DHT22MOD - REMOVE FOR DHT11
itsa22i
		movf	DHT114,w
		movwf	xcat1
		movf	DHT115,w
		movwf	xcat2	
		
		call	Div10

		movf	xcat1,w
		movwf	DHT115
		clrf	DHT114


		movf	DHT112,w
		movwf	xcat1
		movf	DHT113,w
		movwf	xcat2	
		
		call	Div10

		movf	xcat1,w
		movwf	DHT113
		clrf	DHT112
itsan11i
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;DHT22MOD - REMOVE FOR DHT11





;multiply DHT113 by 10 and add DHT112

		clrf	FahrM
		movf	DHT113,w
		movwf	FahrL
		lslf	FahrL,f
		rlf		FahrM,f
		lslf	FahrL,f
		rlf		FahrM,f
		lslf	FahrL,f
		rlf		FahrM,f			;X8
		movf	DHT113,w
		addwf	FahrL,f
		btfsc	STATUS,C
		incf	FahrM,f
		movf	DHT113,w
		addwf	FahrL,f
		btfsc	STATUS,C
		incf	FahrM,f			;plus 2 = 10x
		movf	DHT112,w
		addwf	FahrL,f
		btfsc	STATUS,C
		incf	FahrM,f			;Add the decimals in DHT112		
		movf	FahrM,w
		movwf	DHT113
		movf	FahrL,w
		movwf	DHT112

;code to reset ints

Fail_ed
		BANKSEL	IOCBP
		clrf	IOCBF			;disable rising edge interrupts on RB5
		bcf		IOCBP,5
		BANKSEL	PORTA

;Code to setup read from ext sensor next:

		bsf		PORTB,2			;Pull high

		BANKSEL	TRISA
		bsf		TRISB,2			;Set pin to input
		clrf	DHT221
		clrf	DHT222
		clrf	DHT223
		clrf	DHT224
		clrf	DHT225
		bsf		DIGflags3,1		;Set ext sensor enabled flag

;Setup interrupts for falling edge pin

		BANKSEL	IOCBP
		clrf	IOCBF			;enable rising edge interrupts on RB2
		bsf		IOCBP,2
		BANKSEL	PORTA
		bsf		INTCON,3
		movlw	.41				;Read 40 bits plus start bit
		movwf	DHTcount		;set number of bits
		bsf		DIGflags2,6		;set new read bits condition
		bcf		INTCON,5		;Disable timer 0 interrupt
		movlw	0x01			;setup T0 for looong delay
		movwf	TMR0
		bcf		INTCON,2		;Clear timer 0 interrupt flag

CallDHTexit	
		retfie




;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;DHT22MOD - REMOVE FOR DHT11
Div10
    	clrf	xcat3 
    	movlw   .16
    	movwf	DVAR	

Div10Loop1
    	rlf		xcat1,w 
    	rlf		xcat2,f   
    	rlf		xcat3,f  
    	rlf		xcat1,f  

    	movlw	.10
    	subwf	xcat3,f        

    	btfsc	STATUS,0 
    	bsf		xcat1,0 
    	btfss	xcat1,0
    	addwf	xcat3,f
    	decfsz	DVAR,f   
    	goto	Div10Loop1 
		return
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;DHT22MOD - REMOVE FOR DHT11

;--------------------------------------------------------------------------------------------------------
CallDHTX						;Read data from sensor EXTERNAL
;--------------------------------------------------------------------------------------------------------

		bcf		INTCON,2		;Clear timer 0 interrupt flag
		bcf		INTCON,5		;Disable timer 0 interrupt
		movlw	0x01			;setup T0 for looong delay
		movwf	TMR0
		btfss	DIGflags2,6		;check read condition
		retfie

		rlf		DHT221,f		;Checksum haha
		rlf		DHT222,f		;Temp fraction (unused in DHT11)
		rlf		DHT223,f		;Temp byte
		rlf		DHT224,f		;RH fraction (unused in DHT11)
		rlf		DHT225,f		;RH byte

		bcf		DHT221,0
		btfsc	PORTB,2
		bsf		DHT221,0

		bsf		INTCON,3
		decfsz	DHTcount,f
		goto	CallDHTexit
		bcf		INTCON,3

		bcf		DIGflags2,7		;clear start condition
		bcf		DIGflags2,6		;clear read condition
;Checksum test
		movf	DHT225,w
		movwf	DHTcount
		movf	DHT224,w
		addwf	DHTcount,f
		movf	DHT223,w
		addwf	DHTcount,f
		movf	DHT222,w
		addwf	DHTcount,w
		xorwf	DHT221,w
		btfss	STATUS,Z
		goto	Fail_edX			;Failed checksum, ignore data
		bsf		DIGflags3,0			;Checksum OK, Set valid ext data



		incf	DHT222,f
		decfsz	DHT222,f
		goto	itsa22e			;Not zero so assume it's a DHT22
		incf	DHT224,f
		decfsz	DHT224,f
		goto	itsa22e			;Not zero so assume it's a DHT22
		goto	itsan11e		;Both zero so assume it's a DHT11



;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;DHT22MOD - REMOVE FOR DHT11
itsa22e
		movf	DHT224,w
		movwf	xcat1
		movf	DHT225,w
		movwf	xcat2	
		
		call	Div10

		movf	xcat1,w
		movwf	DHT225
		clrf	DHT224


		;movf	DHT222,w
		;movwf	xcat1
		;movf	DHT223,w
		;movwf	xcat2	
		
		;call	Div10

		;movf	xcat1,w
		;movwf	DHT223
		;clrf	DHT222
		goto Fail_edX
itsan11e
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;DHT22MOD - REMOVE FOR DHT11






;multiply DHT113 by 10 and add DHT112

		clrf	FahrM
		movf	DHT223,w
		movwf	FahrL
		lslf	FahrL,f
		rlf		FahrM,f
		lslf	FahrL,f
		rlf		FahrM,f
		lslf	FahrL,f
		rlf		FahrM,f			;X8
		movf	DHT223,w
		addwf	FahrL,f
		btfsc	STATUS,C
		incf	FahrM,f
		movf	DHT223,w
		addwf	FahrL,f
		btfsc	STATUS,C
		incf	FahrM,f			;plus 2 = 10x
		movf	DHT222,w
		addwf	FahrL,f
		btfsc	STATUS,C
		incf	FahrM,f			;Add the decimals in DHT222		
		movf	FahrM,w
		movwf	DHT223
		movf	FahrL,w
		movwf	DHT222

;code to reset ints
Fail_edX
		BANKSEL	IOCBP
		clrf	IOCBF			;disable rising edge interrupts on RB2
		bcf		IOCBP,2
		BANKSEL	PORTA
		bcf		DIGflags3,1		;reset to int sensor

		retfie

;--------------------------------------------------------------------------------------------------------
RandomDisp						;Load display effect flags with random data
;--------------------------------------------------------------------------------------------------------


		movf	SR1,w
		andlw	0x0f
		movwf	DispRnd			;1 of 16 random values
		btfss	DispRnd,3
		goto	RandomDisp1
		call	LoadR
		goto	RandomDisp10	;display chosen, select transition

RandomDisp1
		btfss	DispRnd,2
		goto	RandomDisp2
		call	LoadR
		goto	RandomDisp10	;display chosen, select transition

RandomDisp2
		movlw	.1				;number to activate option
		xorwf	DispRnd,w
		btfss	STATUS,Z
		goto	RandomDisp3
		call	LoadC			;Load currently selected temp

RandomDisp3
		movlw	.2				;number to activate option
		xorwf	DispRnd,w
		btfss	STATUS,Z
		goto	RandomDisp4
		call	LoadK			;Load currently selected temp

RandomDisp4
		movlw	.3				;number to activate option
		xorwf	DispRnd,w
		btfss	STATUS,Z
		goto	RandomDisp5
		call	LoadF			;Load currently selected temp

RandomDisp5
		movlw	.0				;number to activate option TEMP FILLER
		xorwf	DispRnd,w
		btfss	STATUS,Z
		goto	RandomDisp10
		call	LoadK		;Load currently selected temp

RandomDisp10
		bcf		DIGflags,7		;flicker transition
		btfsc	SR2,1
		goto	RandomDisp11
		bsf		DIGflags,7		;flicker transition

RandomDisp11
		btfsc	SR2,3
		goto	RandomDisp99
		bcf		DIGflags,0		;cancel forward transition
		bsf		DIGflags,4		;Trigger reverse transition
		bsf		DIGflags2,1		;Trigger reverse transition
		goto	RandomDisp99

RandomDisp99
		return

;--------------------------------------------------------------------------------------------------------
LoadCats						;Load display registers with newly selected data
;--------------------------------------------------------------------------------------------------------

		btfsc	SELflags,1		;C selected?
		goto	LoadC
		btfsc	SELflags,2		;F selected?
		goto	LoadF
		btfsc	SELflags,3		;K selected?
		goto	LoadK
		btfsc	SELflags,4		;blank selected?
		goto	LoadB
		return
LoadC							;Load Celsius data to display registers
		call	LoadOld
		bsf		DIGflags,0		;Trigger transition
		movf	Ccat1,w
		movwf	cat1
		movf	Ccat2,w
		movwf	cat2
		movf	Ccat3,w
		movwf	cat3
		movf	Ccat4,w
		movwf	cat4
		movf	Ccat5,w
		movwf	cat5
		return
LoadF							;Load Fahrenheit data to display registers
		call	LoadOld
		bsf		DIGflags,0		;Trigger transition
		movf	Fcat1,w
		movwf	cat1
		movf	Fcat2,w
		movwf	cat2
		movf	Fcat3,w
		movwf	cat3
		movf	Fcat4,w
		movwf	cat4
		movf	Fcat5,w
		movwf	cat5
		return
LoadK							;Load Kelvin data to display registers
		call	LoadOld
		bsf		DIGflags,0		;Trigger transition
		movf	Kcat1,w
		movwf	cat1
		movf	Kcat2,w
		movwf	cat2
		movf	Kcat3,w
		movwf	cat3
		movf	Kcat4,w
		movwf	cat4
		movf	Kcat5,w
		movwf	cat5
		return
LoadR							;Load RH data to display registers
		call	LoadOld
		bsf		DIGflags,0		;Trigger transition
		movf	Rcat1,w
		movwf	cat1
		movf	Rcat2,w
		movwf	cat2
		movf	Rcat3,w
		movwf	cat3
		movf	Rcat4,w
		movwf	cat4
		movf	Rcat5,w
		movwf	cat5
		return
LoadBB							;Load Blank data and force refresh
		call	LoadOld
		bsf		DIGflags,0		;Trigger transition
LoadB							;Load Blank data to display registers
		movlw	0x0b
		movwf	cat1
		movwf	cat2
		movwf	cat3
		movwf	cat4
		movwf	cat5
		return
LoadOld							;Move cats to old data
		movf	cat1,w
		movwf	Old_cat1
		movf	cat2,w
		movwf	Old_cat2
		movf	cat3,w
		movwf	Old_cat3
		movf	cat4,w
		movwf	Old_cat4
		movf	cat5,w
		movwf	Old_cat5
		return

;--------------------------------------------------------------------------------------------------------
Display_byte					;Send byte to display driver 0-11
;--------------------------------------------------------------------------------------------------------

		bcf		DIGflags2,3
		btfsc	DIGflags2,2
		movf	Catcount,w
		andlw	0x0f
		movwf	DispDig			;Save W for decoding

		movlw	0x0b
		xorwf	DispDig,w
		btfsc	STATUS,Z
		bsf		DIGflags2,3		;Set if cathode is blanked (0b)

		btfss	SELflags,4		;do not switch off individual displays if HV off (cycle 4)
		goto	NotNot
		bcf		DIGflags2,3
		btfss	DIGflags2,0		;RND enable toggle
		bsf		DIGflags2,3		;if RND clr and HV off then blank LEDs (cycle 8)

		movlw	0x0b
		movwf	DispDig	;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


NotNot
		incf	DispDig,f
		decfsz	DispDig,f
		goto	NotZero
		goto	Zero
NotZero
		decfsz	DispDig,f
		goto	NotOne
		goto	One
NotOne
		decfsz	DispDig,f
		goto	NotTwo
		goto	Two
NotTwo
		decfsz	DispDig,f
		goto	NotThree
		goto	Three
NotThree
		decfsz	DispDig,f
		goto	NotFour
		goto	Four
NotFour
		decfsz	DispDig,f
		goto	NotFive
		goto	Five
NotFive
		decfsz	DispDig,f
		goto	NotSix
		goto	Six
NotSix
		decfsz	DispDig,f
		goto	NotSeven
		goto	Seven
NotSeven
		decfsz	DispDig,f
		goto	NotEight
		goto	Eight
NotEight
		decfsz	DispDig,f
		goto	NotNine
		goto	Nine
NotNine
		decfsz	DispDig,f
		goto	NotDP
		goto	DPDP
NotDP
		decfsz	DispDig,f
		goto	NotBlank
		goto	Blank
NotBlank
		return

;--------------------------------------------------------------------------------------------------------
Hex2BCD							;Take value in Hex and convert to 2 BCD digits
;--------------------------------------------------------------------------------------------------------

		clrf	HexAscMSN
		movlw	.10
Hex2BCD1
		incf	HexAscMSN,f
		subwf	HexAscIn,f
		btfsc	STATUS,C
		goto	Hex2BCD1
		decf	HexAscMSN,f
		addwf	HexAscIn,w
		movwf	HexAscLSN
		return

;--------------------------------------------------------------------------------------------------------
longdel                         ;Delay loop for anti ghosting
;--------------------------------------------------------------------------------------------------------

		movf	Dlay0,w
        movwf	DVAR2
d0
		movlw   0x2f
        movwf   DVAR
		clrwdt
d1
        decfsz  DVAR,F
        goto    d1
		call	checkk
        decfsz  DVAR2,F
        goto    d0
		return

;--------------------------------------------------------------------------------------------------------
DPdel                         ;Delay loop for DP
;--------------------------------------------------------------------------------------------------------

		movlw   0x18
        movwf	DVAR2
d0p
		movlw   0x3f
        movwf   DVAR
		clrwdt
d1p
        decfsz  DVAR,F
        goto    d1p
		call	checkk
        decfsz  DVAR2,F
        goto    d0p
		return

;--------------------------------------------------------------------------------------------------------
shortdel                         ;Delay loop preset to FF
;--------------------------------------------------------------------------------------------------------

		movlw	0xff
        movwf    DVAR2   
d00
        decfsz  DVAR2,F
        goto    d00
		return

;--------------------------------------------------------------------------------------------------------
Catt                         ;force cathodes high
;--------------------------------------------------------------------------------------------------------

		call	Blank
		call	longdel
		call	longdel
		return

;--------------------------------------------------------------------------------------------------------
Blank                       ;Set cathodes high
;--------------------------------------------------------------------------------------------------------

		bcf		PORTB,0
		bsf		PORTB,7
		bsf		PORTA,6
		bsf		PORTA,1
		return

;--------------------------------------------------------------------------------------------------------
;Five                       	;Set cathodes to 5,'C,Hz
Two                        ;Set cathodes to 6,%,S Prod
;--------------------------------------------------------------------------------------------------------

		BcF		PORTA,1
		BcF		PORTB,7
		BcF		PORTB,0
		BsF		PORTA,6
		return

;--------------------------------------------------------------------------------------------------------
Zero                         ;Set cathodes to 0,m,V
;Zero                         ;Set cathodes to 0,m,V Prod
;--------------------------------------------------------------------------------------------------------

		BCF		PORTA,1
		BCF		PORTB,7
		BCF		PORTB,0
		BCF		PORTA,6
		return

;--------------------------------------------------------------------------------------------------------
One                         ;Set cathodes to 1,k,T?
;One                         ;Set cathodes to 1,k,T? Prod
;--------------------------------------------------------------------------------------------------------

		BsF		PORTA,1
		BCF		PORTB,7
		BCF		PORTB,0
		BCF		PORTA,6
		return

;--------------------------------------------------------------------------------------------------------
;Two                         ;Set cathodes to 2,n,?
Six                       	;Set cathodes to 5,'C,Hz
;--------------------------------------------------------------------------------------------------------

		BsF		PORTA,1
		BcF		PORTB,7
		BcF		PORTB,0
		BsF		PORTA,6
		return

;--------------------------------------------------------------------------------------------------------
Three                        ;Set cathodes to 3,mu,ohm
;Three                        ;Set cathodes to 3,mu,ohm Prod
;--------------------------------------------------------------------------------------------------------

		BsF		PORTA,1
		BcF		PORTB,7
		BsF		PORTB,0
		BCF		PORTA,6
		return

;--------------------------------------------------------------------------------------------------------
Four                        ;Set cathodes to 4,?,?
;Four                        ;Set cathodes to 4,?,? Prod
;--------------------------------------------------------------------------------------------------------

		BcF		PORTA,1
		BcF		PORTB,7
		BsF		PORTB,0
		BCF		PORTA,6
		return

;--------------------------------------------------------------------------------------------------------
DPDP                        ;Set cathodes to DP,?,? 
;DPDP                        ;Set cathodes to DP,?,? Prod
;--------------------------------------------------------------------------------------------------------

		BcF		PORTA,1
		BcF		PORTB,7
		BsF		PORTB,0
		BsF		PORTA,6
		return

;--------------------------------------------------------------------------------------------------------
;Six                        ;Set cathodes to 6,%,S
Five                         ;Set cathodes to 2,n,? Prod
;--------------------------------------------------------------------------------------------------------

		BcF		PORTA,1
		BsF		PORTB,7
		BsF		PORTB,0
		BCF		PORTA,6
		return

;--------------------------------------------------------------------------------------------------------
Seven                         ;Set cathodes to 7,?,?
;Seven                         ;Set cathodes to 7,?,?
;--------------------------------------------------------------------------------------------------------

		BsF		PORTA,1
		BsF		PORTB,7
		BsF		PORTB,0
		BCF		PORTA,6
		return

;--------------------------------------------------------------------------------------------------------
Eight                        ;Set cathodes to 8,M,F
;Eight                        ;Set cathodes to 8,M,F Prod
;--------------------------------------------------------------------------------------------------------

		BsF		PORTA,1
		BsF		PORTB,7
		BCF		PORTB,0
		BCF		PORTA,6
		return

;--------------------------------------------------------------------------------------------------------
Nine                        ;Set cathodes to 9,P,H?
;Nine                        ;Set cathodes to 9,P,H? Prod
;--------------------------------------------------------------------------------------------------------

		BcF		PORTA,1
		BsF		PORTB,7
		BCF		PORTB,0
		BCF		PORTA,6
		return

;--------------------------------------------------------------------------------------------------------
SaveData					;Save new current data to EEPROM
;--------------------------------------------------------------------------------------------------------

		bcf		INTCON,7		;Interrupts off
		BANKSEL	EEADRL			;Start row erase
		movlw	0xe0
		movwf	EEADRL
		movlw	0x07
		movwf	EEADRH
		bsf		EECON1,EEPGD
		bcf		EECON1,CFGS
		bsf		EECON1,FREE
		bsf		EECON1,WREN
		movlw	0x55
		movwf	EECON2
		movlw	0xaa
		movwf	EECON2	
		bsf		EECON1,WR
		nop
		nop
		bcf		EECON1,WREN

		movlw	0xe0			;Start loading data
		movwf	EEADRL
		movlw	0x07
		movwf	EEADRH
		bsf		EECON1,EEPGD
		bcf		EECON1,CFGS
		bsf		EECON1,LWLO
		bsf		EECON1,WREN
		movlw	0x34
		movwf	EEDATH
		movf	SELflags,w
		movwf	EEDATL

		movlw	0x55
		movwf	EECON2
		movlw	0xaa
		movwf	EECON2	
		bsf		EECON1,WR
		nop
		nop
		incf	EEADRL,f

		movlw	0x00
		movwf	EEDATH
		movlw	0x10
		movwf	EEDATL
		movlw	0x55
		movwf	EECON2
		movlw	0xaa
		movwf	EECON2	
		bsf		EECON1,WR
		nop
		nop

		bcf		EECON1,LWLO
		movlw	0x55
		movwf	EECON2
		movlw	0xaa
		movwf	EECON2	
		bsf		EECON1,WR
		nop
		nop

		bcf		EECON1,WREN
		BANKSEL	PORTA
		bsf		INTCON,7		;Interrupts on
		return

;--------------------------------------------------------------------------------------------------------

		end

